//
//  MMILogger.h
//
//
//  Created by Martin Redington on 11/22/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

//
// Copyright 2005-2006 MildMannered Industries. All right reserved.
// 
//

#import <Cocoa/Cocoa.h>


@class MMIError;


#define LOGSTRING(...) [NSString stringWithFormat:__VA_ARGS__]

// Logging class, based on log4j

typedef enum _MSLogLevel {
    MSLLAll = 0,
    MSLLTrace = 1,
    MSLLDebug = 2,
    MSLLInfo = 3,
    MSLLWarn = 4,
    MSLLError = 5,
    MSLLFatal = 6,
    MSLLOff = 7,
} MSLogLevel;


@interface MMILogger : NSObject {
    NSString *mName;
}

+ (void) cleanup;

+ (NSString *) logFilePath;

+ (MMILogger *) logger:(NSString *) loggerName;

+ (MMILogger *) logger;

+ (BOOL) logToStdErr;

+ (void) setLogToStdErr:(BOOL) logToStdErr;

+ (MSLogLevel) level;

+ (void) setLevel:(MSLogLevel) level;

- (id) initWithName:(NSString *)loggerName;

- (void) dealloc;

- (NSString *)name;

- (void) trace:(NSString *) message;

- (void) debug:(NSString *) message;

- (void) info:(NSString *) message;

- (void) warn:(NSString *) message;

- (void) error:(NSString *) message;

- (void) fatal:(NSString *) message;

- (void) dump:(NSString *) message;

+ (NSString *) logFilePathForApp:(NSString *) appName error:(MMIError **)errPtr;

@end
